import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
public class JEAllgemeinD extends javax.swing.JDialog implements ActionListener
{
	public JEAllgemeinD(Einstellungen einstellungen)
	{
		super();
		this.einstellungen=einstellungen;
		setTitle("Einstellungen Allgemein");
		setModal(true);
		getContentPane().setLayout(new BorderLayout());
		JPanel p2=new JPanel();
		p2.add(CancelB);
		p2.add(OKB);
		getContentPane().add(p2,BorderLayout.SOUTH);
		JPanel p1=new JPanel();
		p1.setLayout(new GridLayout(5,2));
		setSize(400,200);
		setVisible(false);
		JLabel1.setText("Standart Rundenzahl");
		p1.add(JLabel1);
		RundenzahlTF.setText("");
		RundenzahlTF.setColumns(10);
		RundenzahlTF.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
		this.automaticRoundsTF.setColumns(10);
		this.automaticRoundsTF.setText(String.valueOf(einstellungen.getRoundsWithoutUser()));
		this.sizeOfUmgebungTF.setColumns(10);
		this.numberAgentsTF.setColumns(10);
		p1.add(RundenzahlTF);
		p1.add(new JLabel("Runden mit automatischer Bewertung"));
		p1.add(automaticRoundsTF);
		p1.add(userInteractionCB);
		p1.add(interactionModeCB);
		p1.add(new JLabel("Groesse der Umgebung"));
		p1.add(sizeOfUmgebungTF );
		p1.add(new JLabel("Anzahl der Agenten"));
		p1.add(numberAgentsTF);
		getContentPane().add(p1,BorderLayout.CENTER);
		CancelB.addActionListener(this);
		OKB.addActionListener(this);
	}

	public void setVisible(boolean b)
	{
	        RundenzahlTF.setText(String.valueOf(einstellungen.getStandartRundenzahl() ));
		this.automaticRoundsTF.setText(String.valueOf(einstellungen.getRoundsWithoutUser()));
		this.numberAgentsTF.setText(String.valueOf(einstellungen.getNumberAgents()));
		this.sizeOfUmgebungTF.setText(String.valueOf(einstellungen.getSizeOfUmgebungen() ));
		this.interactionModeCB.setSelected(einstellungen.getInteractionMode());
		this.userInteractionCB.setSelected(einstellungen.getAutomaticFitness());
		setLocation(50, 50);
		super.setVisible(b);
	}
	public void actionPerformed(ActionEvent e)
	{
	    Object o=e.getSource();
	    if(o==OKB)
	    {
		int puffer;
		try{
		    puffer=Integer.parseInt(RundenzahlTF.getText());
		}catch(Exception ex){puffer=500;}
		einstellungen.setStandartRundenzahl(puffer);
		try{
		    puffer=Integer.parseInt(automaticRoundsTF.getText());
		}catch(Exception ex){puffer=100;}
		einstellungen.setRoundsWithoutUser(puffer);
		try{
                    puffer=Integer.parseInt(this.numberAgentsTF.getText());
		}catch(Exception ex){puffer=5;}
		einstellungen.setNumberAgents(puffer);
		try{
		    puffer=Integer.parseInt(this.sizeOfUmgebungTF.getText());
		}catch(Exception ex){puffer= 71;}
		einstellungen.setSizeOfUmgebungen(puffer);
		einstellungen.setAutomaticFitness(this.userInteractionCB.isSelected());
		einstellungen.setInteractionMode(this.interactionModeCB.isSelected());
                this.setVisible(false);

	    }
	    else if(o==CancelB)
	    {
		this.setVisible(false);
	    }
	}

	private javax.swing.JCheckBox interactionModeCB = new javax.swing.JCheckBox("Interaktionsmodus");
	private javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	private javax.swing.JTextField RundenzahlTF = new javax.swing.JTextField();
	private javax.swing.JCheckBox userInteractionCB=new javax.swing.JCheckBox("automatischer Lauf",false);
	private javax.swing.JTextField automaticRoundsTF=new javax.swing.JTextField();
	private JButton OKB= new JButton("OK");
	private JButton CancelB=new JButton("Abbruch");
	private Einstellungen einstellungen;
	private javax.swing.JTextField numberAgentsTF = new javax.swing.JTextField();
	private javax.swing.JTextField sizeOfUmgebungTF = new javax.swing.JTextField();
}