import java.awt.*;
import javax.swing.*;
/**
 * Title: JReviewDialog
 * Description: This dialog is used to take a deeper look at the different phases
 * of building processes. You can move forward and backward.
 * @author Dimitri Missoh & Daniel Schlosser
 * @version 0.1
 */

public class JReviewDialog extends javax.swing.JDialog
{
    //meine Variablen
    TheHive papa;
    int aktuelleRunde;
    int nRunden;
    //unsere Funktionen
    public void setActualRound(int aRound){
          aktuelleRunde=aRound;
          rundeTF.setText(String.valueOf(aktuelleRunde));
          rundeTF.update(rundeTF.getGraphics());
    }

	public JReviewDialog(TheHive parent)
	{
		super(parent);
		papa=parent;
		setTitle("Review");
		getContentPane().setLayout(new BorderLayout(0,0));
		setSize(405,200);
		setVisible(false);
		JPanel1.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		getContentPane().add(BorderLayout.SOUTH,JPanel1);
		exitB.setText("Review abschlieen");
		exitB.setActionCommand("Review abschlieen");
		JPanel1.add(exitB);
		JPanel2.setLayout(new BorderLayout(0,0));
		getContentPane().add(BorderLayout.CENTER,JPanel2);
		JPanel3.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		JPanel2.add(BorderLayout.NORTH,JPanel3);
		JLabel1.setText("Aktuelle Runde:");
		JPanel3.add(JLabel1);
		rundeTF.setColumns(10);
		JPanel3.add(rundeTF);
		JPanel4.setLayout(new BorderLayout(0,0));
		JPanel2.add(BorderLayout.WEST,JPanel4);
		JPanel5.setLayout(new GridLayout(3,1,0,0));
		JPanel4.add(BorderLayout.WEST,JPanel5);
		JPanel6.setLayout(new BorderLayout(0,0));
		JPanel2.add(JPanel6);
		JPanel7.setLayout(new GridLayout(3,1,0,0));
		JPanel6.add(BorderLayout.WEST,JPanel7);
		oneBackB.setText("zurck");
		JPanel7.add(oneBackB);
		nBackB.setText("zurck");
		JPanel7.add(nBackB);
		genesisB.setText("Ganz zum Anfang");
		JPanel7.add(genesisB);
		JPanel8.setLayout(new GridLayout(3,1,0,0));
		JPanel6.add(BorderLayout.EAST,JPanel8);
		JPanel9.setLayout(new GridLayout(3,1,0,0));
		JPanel6.add(BorderLayout.EAST,JPanel9);
		oneFowardB.setText("vor");
		JPanel9.add(oneFowardB);
		nFowardB.setText("vor");
		JPanel9.add(nFowardB);
		endB.setText("Ganz ans Ende");
		JPanel9.add(endB);
		JPanel10.setLayout(new GridLayout(3,1,0,0));
		JPanel6.add(JPanel10);
		JLabel2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		JLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JLabel2.setText("Eine Runde");
		JPanel10.add(JLabel2);
		JPanel11.setLayout(new FlowLayout(FlowLayout.CENTER,1,3));
		JPanel10.add(JPanel11);
		nTF.setColumns(7);
		JPanel11.add(nTF);
		JLabel3.setText("Runden");
		JPanel11.add(JLabel3);
		rundeTF.setText(String.valueOf(aktuelleRunde));
		nTF.setText("2");
		nRunden=2;
		SymAction lSymAction = new SymAction();
		nTF.addActionListener(lSymAction);
		exitB.addActionListener(lSymAction);
		oneBackB.addActionListener(lSymAction);
		oneFowardB.addActionListener(lSymAction);
		nBackB.addActionListener(lSymAction);
		nFowardB.addActionListener(lSymAction);
		genesisB.addActionListener(lSymAction);
		endB.addActionListener(lSymAction);
		rundeTF.addActionListener(lSymAction);
	}

	public void setVisible(boolean b)
	{
		if (b)
			setLocation(50, 50);
		super.setVisible(b);
	}

	javax.swing.JPanel JPanel1 = new javax.swing.JPanel();
	javax.swing.JButton exitB = new javax.swing.JButton();
	javax.swing.JPanel JPanel2 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel3 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField rundeTF = new javax.swing.JTextField();
	javax.swing.JPanel JPanel4 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel5 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel6 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel7 = new javax.swing.JPanel();
	javax.swing.JButton oneBackB = new javax.swing.JButton();
	javax.swing.JButton nBackB = new javax.swing.JButton();
	javax.swing.JButton genesisB = new javax.swing.JButton();
	javax.swing.JPanel JPanel8 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel9 = new javax.swing.JPanel();
	javax.swing.JButton oneFowardB = new javax.swing.JButton();
	javax.swing.JButton nFowardB = new javax.swing.JButton();
	javax.swing.JButton endB = new javax.swing.JButton();
	javax.swing.JPanel JPanel10 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JPanel JPanel11 = new javax.swing.JPanel();
	javax.swing.JTextField nTF = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == nTF)
				nTF_actionPerformed(event);
			else if (object == exitB)
				exitB_actionPerformed(event);
			else if (object == oneBackB)
				oneBackB_actionPerformed(event);
			else if (object == oneFowardB)
				oneFowardB_actionPerformed(event);
			else if (object == nBackB)
				nBackB_actionPerformed(event);
			else if (object == nFowardB)
				nFowardB_actionPerformed(event);
			else if (object == genesisB)
				genesisB_actionPerformed(event);
			else if (object == endB)
				endB_actionPerformed(event);
			else if (object == rundeTF)
				rundeTF_actionPerformed(event);
		}
	}

	void nTF_actionPerformed(java.awt.event.ActionEvent event)
	{
		int puffer;
		try{
		    puffer=Integer.parseInt(nTF.getText());
		}catch(Exception e){
		    puffer=2;
		}
		nTF.setText(String.valueOf(puffer));
		nRunden=puffer;
	}

	void exitB_actionPerformed(java.awt.event.ActionEvent event)
	{
		this.setVisible(false);
	}

	void oneBackB_actionPerformed(java.awt.event.ActionEvent event)
	{
                rundeTF_actionPerformed(event);
                papa.stepNRoundsBack(1);
	}

	void oneFowardB_actionPerformed(java.awt.event.ActionEvent event)
	{
                rundeTF_actionPerformed(event);
		papa.stepNRoundsForward(1);
	}

	void nBackB_actionPerformed(java.awt.event.ActionEvent event)
	{
                rundeTF_actionPerformed(event);
		nTF_actionPerformed(event);
                papa.stepNRoundsBack(nRunden);
	}

	void nFowardB_actionPerformed(java.awt.event.ActionEvent event)
	{
                rundeTF_actionPerformed(event);
	        nTF_actionPerformed(event);
                papa.stepNRoundsForward(nRunden);
	}

	void genesisB_actionPerformed(java.awt.event.ActionEvent event)
	{
		papa.stepToGenesis();
	}

	void endB_actionPerformed(java.awt.event.ActionEvent event)
	{
		papa.stepToEnd();
	}

	void rundeTF_actionPerformed(java.awt.event.ActionEvent event)
	{
		int puffer;
		try
                {
		        puffer=Integer.parseInt(rundeTF.getText());
		}
                catch(Exception e)
                {
		    puffer=this.aktuelleRunde;
		}
		if(puffer<aktuelleRunde)
		    papa.stepNRoundsBack(aktuelleRunde-puffer);
		else
		    papa.stepNRoundsForward(puffer-aktuelleRunde);
	}
}